;APS00000145000001450000014500000145000001450000014500000145000001450000014500000145
;////////////////////////////////////////////////////////////////////////////
;// Main Code for the #Amycoders TextureCompo.
;// Coded by E-Moon/Endzeit

ASMONE	equ	1				; 1 = ShowSize in AsmOne

		Section	Start,Code
						; 0 = No SizeShow
		jmp	Start

		incdir	"asmpro:texcompo/"	; Set your own dir here.
		include	"bmp.i"

		Section	Code,Code
Start	
		lea	TextureBuffer,a0
		jsr	GenerateTexture		; Generate Texture

		lea	TextureBuffer,a0
		jsr	SaveBmpFile		; Save down the file.
		rts	

;////////////////////////////////////////////////////////////////////
;// Here goes your texture code
;//
;// a0 = Pointer to a 256*256*4 buffer

; cupid/unique
; be patient, takes a little while to execute.. well, with a slow cpu,
; anyway.. i love everyone right now. hmm.. only 118 bytes.. oh well,
; bye

GenerateTexture

		lea	p(pc),a5
		moveq.l	#3-1,d1
.loop:
		addq.l	#1,a0
		move.l	a0,a1

		move.w	(a5)+,a2		; a
		move.w	#256-1,d7
.yloop:
		addq.l	#1,a2			; a=a+i

		move.w	(a5),a3			; b
		move.w	#256-1,d6
.xloop:
		addq.l	#1,a3			; b=b+i

		move.w	a2,d2			; x=a
		move.w	a3,d3			; y=b
		clr.l	d4			; k=0

.kloop:
		move.w	d2,d0			; z=x		4.12
		muls.w	d2,d2			; x*x		8.24
		move.w	d3,d5			;     ..
		muls.w	d5,d5			;     y*y	8.24
		sub.l	d5,d2			;    -		8.24
		lsr.l	#8,d2
		lsr.l	#4,d2			; 		4.12
		add.w	a2,d2			;        +a	4.12

		muls.w	d0,d3			; z*y		8.24
		lsr.l	#8,d3			;
		lsr.l	#3,d3			; 		4.12 (*2)
		add.w	a3,d3			;    +b

		move.w	d2,d0			; ..
		move.w	d3,d5			;     ..
		muls.w	d0,d0			; x*x 		8.24
		muls.w	d5,d5			;     y*y	8.24
		add.l	d5,d0			;    +		8.24
		lsr.l	#8,d0
		lsr.l	#4,d0			; 		4.12

		tst.w	d0			; ... > 127
		bmi.b	.ok

		add.b	#1,d4			; k > 255
		cmp.b	#63,d4
		blo.b	.kloop

.ok

		lsl.b	#2,d4
		move.b	d4,(a1)
		addq.l	#4,a1

		dbra	d6,.xloop
		dbra	d7,.yloop
		addq.l	#2,a5

		dbra	d1,.loop

		rts
p:
		dc.w	0,-2800
		dc.w	500,-2600
		dc.w	700,2200
.EndGenerate
		rts

	IFNE	ASMONE
		printt "Code Size:"
		printv	GenerateTexture-.EndGenerate
	ENDC	


TextureName	dc.b	"texture.bmp",0,0,0,0	; !!!

		section	Texturebuffer,bss

TextureBuffer	ds.l	256*256

