;APS00000141000001410000014100000141000001410000014100000141000001410000014100000141
;////////////////////////////////////////////////////////////////////////////
;// Main Code for the #Amycoders TextureCompo.
;// Coded by E-Moon/Endzeit

ASMONE	equ	1				; 1 = ShowSize in AsmOne

		Section	Start,Code
						; 0 = No SizeShow
		jmp	Start

		incdir	"sources:tekstura/"		; Set your own dir here.
		include	"bmp.i"

		Section	Code,Code
Start	
		lea	TextureBuffer,a0
		jsr	GenerateTexture		; Generate Texture

		lea	TextureBuffer,a0
		jsr	SaveBmpFile		; Save down the file.
		rts	

;////////////////////////////////////////////////////////////////////
;// Here goes your texture code
;//
;// a0 = Pointer to a 256*256*4 buffer

GenerateTexture

;
;
; 24 bit 128 bytes 256 x 256 texture generator done by
;
;                                                   maq of floppy
;

red:	macro				; macros to write a value r,g or b

	move.b	(a0),(a0)+
	move.b	\1,(a0)+
	move.w	(a0),(a0)+

	endm

green:	macro

	move.w	(a0),(a0)+
	move.b	\1,(a0)+
	move.b	(a0),(a0)+

	endm

blue:	macro

	move.w	(a0),(a0)+
	move.b	(a0),(a0)+
	move.b	\1,(a0)+

	endm

all:	macro

	move.b	\1,(a0)+
	move.b	\1,(a0)+
	move.b	\1,(a0)+
	move.b	\1,(a0)+

	endm
;---------------------------------------------------------------------


	clr.w	d0

	move.w	#256-1,d6		; fade left to right
.loop01:
	move.w	#256-1,d7
.loop00:

	green	d0

	add.b	#1,d0
	dbf	d7,.loop00
	dbf	d6,.loop01


	lea	TextureBuffer,a0	; fade up to down
	clr.b	d0
	move.w	#256-1,d6
.loop03:
	move.w	#256-1,d7
.loop02:

	red	d0

	dbf	d7,.loop02
	add.b	#1,d0
	dbf	d6,.loop03



	lea	TextureBuffer,a0	; fade 45
	clr.b	d0
	clr.b	d1
	move.b	#1,d2
	move.w	#256-1-1,d6
.loop04:
	move.w	#256-1,d7
.loop05:

	blue	d0

	add.b	d2,d0
	cmp.b	#255,d0
	bne	.no255
	neg.b	d2
.no255:
	dbf	d7,.loop05
	add.b	#1,d1
	move.b	d1,d0
	move.b	#1,d2
	dbf	d6,.loop04


;---------------------------------------------------------------------



.EndGenerate
		rts

	IFNE	ASMONE
		printt "Code Size:"
		printv	.EndGenerate-GenerateTexture
	ENDC	


TextureName	dc.b	"dh1:texture.bmp",0,0,0,0

		section	Texturebuffer,bss

TextureBuffer	ds.l	256*256

