;
; Contribution for the #amycoders 128 bytes texture compo
; by Psycho/Loonies <psycho@loonies.dk>
;
; Nothing really special but IMHO quite nice colors :)
;
; Code size without last rts: 128 bytes
;

;////////////////////////////////////////////////////////////////////////////
;// Main Code for the #Amycoders TextureCompo.
;// Coded by E-Moon/Endzeit

ASMONE  equ     0                               ; 1 = ShowSize in AsmOne

                Section Start,Code
                                                ; 0 = No SizeShow
                jmp     Start

                incdir  "code:texcompo"           ; Set your own dir here.
                include "bmp.i"

                Section Code,Code
Start   
                lea     TextureBuffer,a0
                jsr     GenerateTexture         ; Generate Texture

                lea     TextureBuffer,a0
                jsr     SaveBmpFile             ; Save down the file.
                rts     

;////////////////////////////////////////////////////////////////////
;// Here goes your texture code
;//
;// a0 = Pointer to a 256*256*4 buffer

GenerateTexture
  lea.l   table,a1          ;6
  movem.l (a1),d0-d7        ;4

  subq.b  #1,d7             ;2   sine like tablegeneration..
.firkant
  move.b  d7,(a1,d6)        ;4
  subq.b  #1,d6             ;2
  bmi.s   .firkant          ;2

  moveq   #8,d4             ;2
.taelned
  move.w  #512,d5           ;4
.udglat
  move.b  d0,(a1,d6)        ;4
  add.b   d4,d6             ;2
  move.b  (a1,d6),d0        ;4
  move.b  d5,d6             ;2
  sub.b   d4,d6             ;2
  move.b  (a1,d6),d1        ;4
  add.w   d1,d0             ;2
  lsr.w   #1,d0             ;2
  move.b  d5,d6             ;2
  subq.w  #1,d5             ;2
  bpl.s   .udglat           ;2

  subq.b  #1,d4             ;2
  bgt.s   .taelned          ;2


.yloop
.xloop
  moveq   #0,d0             ;2   filling the texture..
  move.l  d7,d2             ;2
  bsr.s   sinelike          ;2
  add.l   d6,d2             ;2
  bsr.s   sinelike          ;2
  add.l   d6,d2             ;2
  lsl.l   #2,d2             ;2
  bsr.s   sinelike          ;2
  move.l  d6,d2             ;2
  sub.l   d7,d2             ;2
  bsr.s   sinelike          ;2
  lsr.w   #2,d0             ;2
  swap    d0                ;2

  neg     d2                ;2
  bsr.s   sinelike          ;2
  move.l  d6,d2             ;2
  bsr.s   sinelike          ;2
  add.l   d7,d2             ;2
  bsr.s   sinelike          ;2
  add.l   d6,d2             ;2
  bsr.s   sinelike          ;2
  lsr.w   #2,d0             ;2
  lsl.w   #8,d0             ;2

  move.l  d6,d2             ;2
  add.l   d7,d2             ;2
  bsr.s   sinelike          ;2

  move.l  d0,(a0)+          ;2
  addq.b  #1,d6             ;2
  bne.s   .xloop            ;2
  dbf.s   d7,.yloop         ;4

  ;reusing the rts below..

sinelike
  move.b  d2,d1             ;2
  move.b  (a1,d1),d1        ;4
  add.l   d1,d0             ;2

                            ;  128 bytes total
  rts
.EndGenerate
                

        IFNE    ASMONE
                printt "Code Size:"
                printv  GenerateTexture-.EndGenerate
        ENDC    


TextureName     dc.b    "texture.bmp",0,0,0,0

                section Texturebuffer,bss

TextureBuffer   ds.l    256*256

table           blk.b   256,0



