;APS00000141000001410000014100000141000001410000014100000141000001410000014100000141
;////////////////////////////////////////////////////////////////////////////
;// Main Code for the #Amycoders TextureCompo.
;// Coded by E-Moon/Endzeit

ASMONE	equ	1				; 1 = ShowSize in AsmOne

		Section	Start,Code
						; 0 = No SizeShow
		jmp	Start

		incdir	"Sources:_TxtCompo/"	; Set your own dir here.
		include	"bmp.i"

		Section	Code,Code
Start	
		lea	TextureBuffer,a0
		jsr	GenerateTexture		; Generate Texture

		lea	TextureBuffer,a0
		jsr	SaveBmpFile		; Save down the file.
		rts	



; Texture generate routine by Aln!/Appendix+Mawi (16.05.99)
; Especially for #amycoders TextureCompo
;
; KurwaNieWiem

GenerateTexture

RAND:	MACRO
	rol.l	\1,\1
	addq.l	#5,\1
	ENDM

;	lea	(Kwiki),a1

;	move.l	#(KoniecKwikow-Kwiki)>>2,d0
.FillLoop:

;	move.l	#$348070,(a1)+
;	subq.l	#1,d0
;	bgt.b	.FillLoop



	lea	(TempBuffer),a1
	moveq	#-37,d7


	moveq	#32-1,d6
.MainLoop:

	clr.l	d0

	moveq	#24-1,d5
.RandLoop:

	RAND	d7
	move.w	d7,d0
	RAND	d7
	add.l	d7,(a0,d0.l*4)
	dbra	d5,.RandLoop


	move.l	a0,a2
	subq.l	#4,a2
	move.l	a1,a3

	moveq	#4,d5
	swap	d5
.DropsLoop:

	clr.l	d0
	clr.l	d1
	move.b	(a2)+,d0
	move.b	(1*4+3,a2),d1
	add.w	d1,d0
	move.b	(256*4+3,a2),d1
	add.w	d1,d0
	move.b	(-256*4+3,a2),d1
	add.w	d1,d0

	lsr.w	#1,d0
	move.b	(a3),d1
	sub.w	d1,d0
	move.b	(-4,a3),d1
	add.w	d1,d0
	asr.w	#1,d0

	bge.w	.LowOK
	clr.l	d0
.LowOK:
	cmp.w	#$FF,d0
	ble.b	.HighOK
	moveq	#-1,d0
.HighOK:
	move.b	d0,(a3)+

	subq.l	#1,d5
	bgt.b	.DropsLoop

	exg	a0,a1

	dbra	d6,.MainLoop






.EndGenerate
		rts

	IFNE	ASMONE
		printt "Code Size:"
		printv	.EndGenerate-GenerateTexture
	ENDC	


TextureName	dc.b	"texture.bmp",0,0,0,0

		section	Texturebuffer,bss

Kwiki:
		ds.l	256

TextureBuffer	ds.l	256*256

		ds.l	256
TempBuffer:
		ds.l	256*256

		ds.l	256
KoniecKwikow:
