;// Main Code for the #Amycoders TextureCompo.
;// Coded by E-Moon/Endzeit

	output dh1:platon_tx.exe
	opt	w-

ASMONE	equ	0				; 1 = ShowSize in AsmOne

		Section	Start,Code
						; 0 = No SizeShow
		jmp	Start

;		incdir	"dh1:coding/"		; Set your own dir here.
		include	"bmp.i"

		Section	Code,Code
Start	
		move.l	#'HURZ',d0
		move.l	d0,Chk1
		move.l	d0,Chk2
		lea	TextureBuffer,a0
		jsr	GenerateTexture		; Generate Texture

		lea	TextureBuffer,a0
		jsr	SaveBmpFile		; Save down the file.
		moveq.l	#20,d0
		cmp.l	#'HURZ',Chk1
		bne.s	.err
		moveq.l	#10,d0
		cmp.l	#'HURZ',Chk2
		bne.s	.err
		moveq.l	#0,d0
.err		rts
	
;////////////////////////////////////////////////////////////////////
;// Here goes your texture code
;//
;// a0 = Pointer to a 256*256*4 buffer
;
; 128 Bytes Texture Generator V1.1 (15-May-99).
; Written by Chris 'Platon42' Hodges <platon@cu-muc.de>
; Dedicated to my girlfriend Heike, who also contributed her opinion.

TextureNum	equ	0

	dc.l	'STRT'
GenerateTexture
	moveq.l	#-1,d7
	move.l	a0,d1
.fillit	divu	#$BC42,d1
	move.l	d1,(a0)+
 	dbra	d7,.fillit

	moveq.l	#2,d5
	subq.l	#1,a0
.rgblop	subq.l	#1,a0
	IFEQ	TextureNum
	moveq.l	#16-1,d6
	ELSE
	moveq.l	#38-1,d6
	ENDC
.redo	move.l	a0,a1
.loopy	move.b	(a1)+,d1
	and.w	#$7,d1
	move.l	d7,d4
	add.w	.tab(pc,d1.w*2),d4
	lea	5(a0,d4.l*4),a2
	move.b	(a2),d1
	lsr.b	#3,d1
	sub.b	d1,(a2)

	moveq.l	#0,d4
	moveq.l	#0,d3
	IFEQ	TextureNum
	move.b	-256*4(a1),d3
	move.b	-1*4(a1),d4
	add.w	d4,d3
	move.b	(a1),d4
	add.w	d4,d3
	move.b	1*4(a1),d4
	add.w	d4,d3
	move.b	256*4(a1),d4
	add.w	d4,d3
	divu	#5,d3
	subq.w	#5,d3
	ELSE
	move.b	-256*4(a1),d3
	move.b	-2*4(a1),d4
	add.w	d4,d3
	move.b	(a1),d4
	add.w	d4,d3
	move.b	1*4(a1),d4
	add.w	d4,d3
	move.b	512*4(a1),d4
	add.w	d4,d3
	divu	#5,d3
	subq.w	#3,d3
	ENDC
	bpl.s	.nomi
	moveq.l	#0,d3
.nomi	add.b	d1,d3
	bcc.s	.noover
	st	d3
.noover	move.b	d3,(a1)
.over	lsr.b	#4,d1
	add.b	d1,-(a1)
	subq.l	#4,a1
	dbra	d7,.loopy
	dbra	d6,.redo
	dbra	d5,.rgblop
	rts

.tab
	IFEQ	TextureNum
	dc.w	-3		; -1, 0
	dc.w	-257		; -1,-1
	dc.w	-256*3		;  0,-2
	dc.w	-255		;  1,-1
	dc.w	40		;  2, 0
	dc.w	257		;  1, 1
	dc.w	256*3		;  0, 2
	dc.w	255		; -1, 1
	ELSE
	dc.w	-42		; -1, 0
	dc.w	-257		; -1,-1
	dc.w	-256		;  0,-2
	dc.w	-255-256	;  1,-1
	dc.w	42		;  2, 0
	dc.w	257		;  1, 1
	dc.w	256		;  0, 2
	dc.w	255		; -1, 1
	ENDC
.EndGenerate


	dc.l	'SIZE'
	dc.l	.EndGenerate-GenerateTexture

	IFNE	ASMONE
		printt "Code Size:"
		printv	GenerateTexture-.EndGenerate
	ENDC	


TextureName
	IFEQ	TextureNum
	dc.b	"platon_texture0.bmp",0,0,0,0
	ELSE
	dc.b	"platon_texture1.bmp",0,0,0,0
	ENDC
		section	Texturebuffer,bss

Chk1	ds.l	1
TextureBuffer	ds.l	256*256
Chk2	ds.l	1